/* $Id: formt.java,v 1.23 2013/02/28 07:17:32 mit Exp $ */
/* formt.java (Formant) v0.6 */
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.awt.event.*;
import java.net.*;
import java.text.DecimalFormat;

public class formt extends Applet 
    implements ActionListener, ItemListener, AdjustmentListener
{
    private final int WAVE = 0;
    private final int FORMT = 1;
    private final String[] Graph = {"Wave", "Formt"};

    private boolean GT;   // graph./text
    private boolean Csw;  // calc. sw.
    private boolean BL;   // bar/line
    private int W, H, H2, HBase;
    private int FNT;
    private int AF;    // all_file_num.
    private int M;     //
    private int L;     // ץμ
    private int LL;    // waveǡοκ缫
    private int Splngf;
    private int NP;    // ץ(2ξ)
    private int Cnt;   // waveǡ
    private int Npk;
    private int Wby;
    private int Wmax;
    private int GRAP;
    private int START; // waveϰ
    private int FORMT_COUNT;
    private double DELF;
    private double Gain;
    private double Wgain = 0.005; // wave
    private int[] Wave;  // waveǡ
    private double[] fi;
    private double[] pkp;
    private double[] bw;
    private double[] a;
    private double[] x;
    private double[] y;
    private double[] s;
    private String[] filenm;
    private String Error;
    private String Dirnm;
    private Color DDGray = new Color(42, 42, 42);

    private TextField tfA;
    private Choice chFile;     // file
    private Choice chL;
    private Scrollbar scrWave;
    private Button btPP, btPM; // page
    private Button btWP, btWM; // <,>
    private Button btMP, btMM; // M
    private Button btGT;       // graph./text
    private Button[] btGraph;
    private TextArea taA;
    private Label lM;
    private Panel deck;
    private CardLayout Card;
    private Canvas can;
    private Panel PN, PR, PW, PS;

    private Graphics gi;
    private Image im;
    private Font Fnt;
    private FontMetrics fm;
    private DecimalFormat df1;
    private FFT fftN;

    public void init() {
	String fnt = getParameter("font");
        FNT = (fnt != null) ? Integer.parseInt(fnt) : 12;
        Fnt = new Font("SansSerif", Font.PLAIN, FNT);
	setFont(Fnt);
	fm = getFontMetrics(Fnt);
	df1 = new DecimalFormat("#0.0#");

	buildLayout();
	init_start();
	set_enabled();
    }
    public void buildLayout() {
	setLayout(new BorderLayout());
	setBackground(Color.lightGray);

	deck = new Panel();
	Card = new CardLayout();
        deck.setLayout(Card);
	int i;

	PN = new Panel();
	PN.setLayout(new GridLayout(2,1,0,0));
        add(PN, "North");

	Panel nu = new Panel();
	nu.setLayout(new FlowLayout());
	PN.add(nu);

	tfA = new TextField(22);
	tfA.setForeground(Color.blue);
        tfA.setEditable(false);
        nu.add(tfA);

	String fn = getParameter("all_f");
	AF = (fn == null) ? 0 : Integer.parseInt(fn);
	if (AF == 0)
            Error = "No wave file.";
	Dirnm = getParameter("dirnm");
        Dirnm = (Dirnm == null) ? "" : Dirnm;
	filenm = new String[AF];  // max files
	chFile = new Choice();
	for (i = 0; i < AF; i++) {
	    filenm[i] = getParameter("wave"+i);
       	    chFile.addItem(filenm[i]);
	}
	nu.add(chFile);
        chFile.addItemListener(this);
	//--------------------nu/nd

	Panel nd = new Panel();
	nd.setLayout(new FlowLayout());
	PN.add(nd);

	btMM = new Button("M-");
        nd.add(btMM);
        btMM.addActionListener(this);

	btMP = new Button("M+");
        nd.add(btMP);
        btMP.addActionListener(this);

	lM = new Label(":__");
	nd.add(lM);

	nd.add( new Label("L:"));

	chL = new Choice();
	for (i = 1; i <= 8; i++) {
       	    chL.addItem(""+i);
	}
	nd.add(chL);
        chL.addItemListener(this);
	//-------------------nd/right

	PR = new Panel();
	PR.setLayout(new GridLayout(5,1,0,0));
        add(PR, "East");

	btPP = new Button("+");
        PR.add(btPP);
        btPP.addActionListener(this);

	btPM = new Button("-");
        PR.add(btPM);
        btPM.addActionListener(this);

	PR.add(new Label());

        btWM = new Button("<");
        PR.add(btWM);
        btWM.addActionListener(this);

	btWP = new Button(">");
        PR.add(btWP);
        btWP.addActionListener(this);
	//---

	PW = new Panel();
	PW.setLayout(new GridLayout(Graph.length+2,1,0,0));
        add(PW, "West");

	btGraph = new Button[Graph.length];
	for (i = 0; i < Graph.length; i++) {
	    btGraph[i] = new Button(Graph[i]);
	    btGraph[i].addActionListener(this);
	    PW.add(btGraph[i]);
        }

	PW.add(new Label());

	btGT = new Button("Grap.");
        btGT.addActionListener(this);
	PW.add(btGT);
	//---

	PS = new Panel();
	PS.setLayout(new GridLayout(1,1,0,0));
        add(PS, "South");

	scrWave = new Scrollbar(Scrollbar.HORIZONTAL,0,0,0,0);
        PS.add(scrWave);
        scrWave.addAdjustmentListener(this);
	//---

	can = new MyCanvas();

	Panel card1 = new Panel();
        card1.add(can);
        deck.add(card1, "card1");

        taA = new TextArea("", 15, 42, TextArea.SCROLLBARS_BOTH);
        taA.setEditable(false);

        ScrollPane card2 = new ScrollPane();
        card2.add(taA);
        deck.add(card2, "card2");

        add(deck, "Center");
    }
    public void start() {
	W = getCanvasD().width;
        H = getCanvasD().height;
	HBase = H-FNT*2;
	H2 = HBase/2;

	can.setSize(W, H);
	im = createImage(W, H);
        gi = im.getGraphics();
        gi.setFont(Fnt);
    }
    public Dimension getCanvasD() {
        Dimension dn = PN.getSize();
        Dimension de = PR.getSize();
	Dimension dw = PW.getSize();
	Dimension ds = PS.getSize();
        Dimension da = getSize();
        int cw = da.width-(de.width+dw.width);
        int ch = da.height-(dn.height+ds.height)-5;
        Dimension can = new Dimension(cw, ch);

        return can;
    }
    public void init_start() {
	M = 15;
	Wby = 2;

	if (isFile()) {
	    read_file(filenm[0]);

	    calc();
	}
    }
    public boolean isFile() {
	return (AF > 0);
    }

    public void adjustmentValueChanged(AdjustmentEvent e) {
	if (e.getSource() == scrWave) {
	    START = scrWave.getValue();
	    Csw = false;
	}

	disp_sw();
    }
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == chFile)         // choice file
	    read_file(chFile.getSelectedItem());

	if (e.getSource() == chL)
	    set_l();

	Csw = false;
	disp_sw();
    }

    public void actionPerformed(ActionEvent e) {
	for (int i = 0; i < Graph.length; i++) {
	    if (e.getSource() == btGraph[i]) {
                set_graph(i);
                break;
            }
	}

	if (e.getSource() == btPP)      // +,-
	    set_page(true);	
	else if (e.getSource() == btPM) 
	    set_page(false);

	else if (e.getSource() == btWP) // <,>
	    set_w(true);
	else if (e.getSource() == btWM)
	    set_w(false);

	else if (e.getSource() == btMM) // M+,-
	    set_m(false);
	else if (e.getSource() == btMP)
	    set_m(true);

	else if (e.getSource() == btGT) // graph./text
	  set_gt();

	set_enabled();
	disp_sw();
    }
    public void set_enabled() {
	btPP.setEnabled(!GT);
	btPM.setEnabled(!GT);
	btWP.setEnabled(!GT);
	btWM.setEnabled(!GT);

	boolean wsw = (GRAP == WAVE);
	btPP.setEnabled(wsw);
	btPM.setEnabled(wsw);
	btWP.setEnabled(!wsw);
	btWM.setEnabled(!wsw);
    }
    public void disp_sw() {
	if (!Csw && isFile())
	    calc();

	if (GT)
            re_write();
        else
            can.repaint();
    }
    public void set_graph(int n) {
	GRAP = n;

	if (GRAP == FORMT) {
	    FORMT_COUNT++;
	    if (FORMT_COUNT > 1) {
		BL = !BL;
		FORMT_COUNT = 0;
	    }
	} else
	    FORMT_COUNT = 0;
    }
    public void set_gt() {
	GT = !GT;

	btGT.setLabel(GT ? "Text" : "Grap.");
	Card.next(deck);
    }
    public void set_page(boolean sw) {
	Wgain = sw ? Wgain*2 : Wgain/2;
    }
    public void set_l() {
	L = Integer.parseInt(chL.getSelectedItem());

	set_np();
	Csw = false;
    }
    public void set_np() {
       	NP = (int)Math.pow(2, L);
	fftN = new FFT(NP);
	DELF = (double)Splngf/NP;

	scrWave.setValues(START, NP, 0, Cnt);
	scrWave.setBlockIncrement(NP);
    }
    public void set_chL() {
	chL.removeAll();

	int maxl = (LL > 16) ? 16 : LL; 
	for (int i = 1; i <= maxl; i++)
       	    chL.addItem(""+i);

	chL.select(maxl-2);
    }
    public void set_m(boolean sw) {
	M = sw ? M+1 : M-1;
	if (M < 1)
	    M = 1;

	Csw = false;
    }
    public void set_w(boolean sw) {
	switch(GRAP) {
	case FORMT:
	    Wby = sw ? Wby/2 : Wby*2; 

	    if (Wby < 2)
		Wby = 2;

	    Csw = false;
	    break;
	default:
	}
    }
    public void read_file(String fname) {
	file_read(Dirnm+fname);
	LL = (int)(Math.log(Cnt)/Math.log(2));

	START = 0;
	set_chL();
	set_l();
    }

    public void calc() {
	setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR)); // 

	Wmax = NP/Wby;  // 2**L/
	int mnp = (NP > M) ? NP+1 : M+2;
	x = new double[mnp];
	y = new double[mnp];
	s = new double[mnp];
	a = new double[M+2];
	fi = new double[M+1];
	pkp = new double[M+1];
	bw = new double[M+1];

	int i;
	for(i = 1; i <= NP; i++)
	    x[i] = Wave[i+START];
	durb();  //...........durbin

	for (i = 1; i <= NP; i++)
	    x[i] = y[i] = 0;
	for(i = 1; i <= M+1; i++)
	    x[i] = a[i];  // durbǻ
	fft();  //.............FFT.java

	Gain = 4.343 * Math.log(Gain);
	for (i = 1; i <= Wmax ; i++) { 
	    s[i] = Math.sqrt(Math.pow(x[i], 2)+Math.pow(y[i], 2));
	    s[i] = Gain-4.343 * Math.log(s[i]);
	}
	fdpk();  //........peak picking

	Csw = true;
	setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
    }

    public void re_write() {
        StringBuffer str = new StringBuffer(1024);
	str.append("# :    [Hz]  :     Band  :    Value \n");
	str.append("------------------------------------\n");	
	for (int i = 1; i <= Npk; ++i) { 
	    str.append(i+": ").append((float)fi[i]);
	    str.append(": ").append((float)bw[i]);
	    str.append(": ").append((float)pkp[i]);
	    str.append("\n");
	}

	taA.setText(str.toString());
    }
    public String dform(double val) {
        return df1.format((float)val);
    }
    //-----

    class MyCanvas extends Canvas {
        public void update(Graphics g) {
            can.paint(g);
        }
	public void paint(Graphics g) {
	    paintI();
            g.drawImage(im, 0, 0, this);
        }
    }
    public void paintI() {
	disp_brack(gi);

	switch(GRAP) {
	case WAVE:
	    disp_wave(gi);
	    break;
	case FORMT:
	    disp_scale(gi);
	    disp_line(gi);
	    break;
	default:
	}
	write_label();

	if (!Error.equals(""))
	    tfA.setText(Error);
    }
    public void disp_brack(Graphics g) {
	g.setColor(Color.black);
	g.fillRect(0, 0, W, H);
    }
    public void write_label() {
	lM.setText(":"+M);
    }
    public void disp_line(Graphics g) {
	double wd = W/(double)Wmax;
	double hm = HBase/200.0;
	int x0 = 0, x1, y0 = 0, y1;

	for (int i = 0; i < Wmax; i++) { // 1->0
	    x1 = (int)(i*wd);
	    y1 = (int)(HBase-s[i+1]*hm); // i+1
	    if (i == 0) {
		x0 = x1;
		y0 = y1;
	    } 
	    if (BL) {                         // bar
		g.setColor(Color.gray);
		g.drawLine(x1, HBase, x1, y1);
	    } else {
		g.setColor(Color.green);      // line
		g.drawLine(x0, y0, x1, y1);
	    }
	    x0 = x1;
	    y0 = y1;
	}
    }
    //
    public void disp_wave(Graphics g) {
	double dw = W/(double)Cnt;
	int val, max = Integer.MIN_VALUE, min = Integer.MAX_VALUE;
	int x1, y1;

	g.setColor(Color.gray);
	g.drawLine(0, H2, W, H2);
	disp_base_line(g);

        for (int i = 0; i < Cnt; i++) {
	    g.setColor((i >= START && i < START+NP) ?
		Color.orange : Color.green);
	    val = Wave[i];
            x1 = (int)(dw*i);
            y1 = (int)(H2-val*Wgain);
	    g.drawLine(x1, y1, x1, y1);

	    max = Math.max(max, val);
            min = Math.min(min, val);
	}

	disp_time(g);
	disp_wave_value(g, min, max);
    }
    public void disp_time(Graphics g) {
	double allsec = Cnt/(double)Splngf;
        double tim = get_tim(allsec);

        String s = "[sec] ";
        g.setColor(Color.yellow);
        g.drawString(s, W-fm.stringWidth(s), H-2);

        double asec = tim/(allsec/W);
        int maxsec = (int)(allsec/tim);
        if (maxsec > 0) {
            int ss = H-FNT;  // ʸh
            int x, l = 5;
            for (int i = 0; i <= maxsec; i++) {
                x = (int)(asec*i);

                g.setColor(Color.gray);
                g.drawLine(x, HBase, x, HBase+l);

                g.setColor(Color.yellow);
                g.drawString(dform(i*tim), x, ss);
            }
        }
    }
    public double get_tim(double allsec) {
        double tim;

        if (allsec < 0.1)
            tim = 0.01;
        else if (allsec < 0.3)
            tim = 0.05;
        else if (allsec < 1)
            tim = 0.1;
        else if (allsec < 3)
            tim = 0.5;
        else if (allsec < 10)
            tim = 1;
        else if (allsec < 30)
            tim = 5;
        else if (allsec < 60)
            tim = 10;
        else
            tim = 60;

        return tim;
    }
    public void disp_wave_value(Graphics g, int min, int max) {
	g.setColor(Color.lightGray);
        g.drawString(dform(100*max/Short.MAX_VALUE)+"[%]", 1, FNT-1);
        g.drawString(dform(100*min/Short.MAX_VALUE)+"[%]", 1, HBase-2);
    } /* ȾȤ100% */
    //
    public void disp_scale(Graphics g) {
	double sd = Wby*W/(double)Splngf;
	int mmax = Splngf/Wby, spi, len;

	for(int i = 0; i <= mmax; i += 10) {
	    if (i % 1000 == 0) {
		disp_k(g, i, sd);
		len = 15; 
		g.setColor(Color.lightGray);
	    } else if (i % 500 == 0) {
		if (mmax > 12000)
		    continue;
		len = 12;
		g.setColor(Color.gray);
	    } else if (i % 100 == 0) {
		if (mmax > 6000)
		    continue;
		len = 10;
		g.setColor(Color.darkGray);
	    } else {
		if (mmax > 1500)
		    continue;
		len = 7;
		g.setColor(DDGray);
	    }

	    spi = (int)(sd*i);
	    g.drawLine(spi, HBase, spi, HBase+len);
	}

	disp_base_line(g);
    }
    public void disp_k(Graphics g, int i, double dx) {
	g.setColor(Color.pink);
	g.drawString(i/1000+"K", (int)(i*dx), H);
    }
    public void disp_base_line(Graphics g) {
	g.setColor(Color.gray);
	g.drawLine(0, HBase, W-1, HBase);
    }
    //
    public void fdpk() {
	int nptm1 = NP/2-1;
	double ym = s[2];
	double yp = s[3];
	boolean kcd = (yp < ym) ? false : true;
	Npk = 0;
	ym = yp;

	int j;
	double a, b, c, gg;
	for (int k = 4; k <= nptm1; ++k) {
	    yp = s[k];
	    if (!kcd) {
		kcd = (yp > ym) ? true : false;
	    } else {
		if (yp < ym) {
		    kcd = false;
		    Npk++;
		    j = k-1;
		    a = (s[j+1]+s[j-1])/2d-s[j];
		    b = (s[j+1]-s[j-1])/2d;
		    c = s[j];
		    fi[Npk] = (-b/(2d*a)+j-1)*DELF;
		    pkp[Npk] = c-b*b/(4d*a);
		    gg = b*b-4d*a*(c-pkp[Npk]/2d);
		    bw[Npk] = Math.abs(Math.sqrt(gg)*DELF/a);
		}
		else
		    kcd = true;
	    }
	    ym = yp;
	}
    }
    public void durb() {
	int mp = M+1;
	double en;
	double[] rk = new double[mp+1];
	double[] r = new double[mp+1];
	double[] b = new double[mp+1];

	for (int k = 1; k <= mp; ++k) {
	    r[k] = 0;
	    for (int n = 1; n <= (NP-k+1); ++n)
	      r[k] += x[n]*x[n+k-1];
	}
	Gain = r[1];
	en = r[1];
	rk[1] = r[2]/r[1];
	a[1] = 1d;
	a[2] = -rk[1];
	en -= rk[1]*rk[1]*en;

	int mm;
	double w;
	for (int minc = 2; minc <= M; ++minc) {
	    mm = minc-1;
	    for (int j = 1; j <= minc; ++j)
		b[j] = a[minc-j+1];
	    mm++;
	    w = 0;
	    for (int ip = 1; ip <= mm; ++ip)
	      w += r[mm-ip+2]*a[ip];
	    rk[mm] = w/en;
	    for (int ip = 2; ip <= mm; ++ip)
		a[ip] -= rk[mm]*b[ip-1];
	    a[mm+1] = -rk[mm];
	    en -= rk[mm]*rk[mm]*en;
	    if (en < 0)
		break;
	}
    }
    public void fft() { // fft.java
        fftN.fft(x, y);
    }
    //---

    public void file_read(String fn) {
	try {
            URL url = new URL(getDocumentBase(), fn);
            ReadWave rw = new ReadWave(url);

            Wave = rw.getData();
	    Splngf = rw.getSamplf();
	    Cnt = rw.getCount();
	    String lavel = rw.getLavel();
            Error = rw.getError();

	    tfA.setText(lavel+Splngf+"[Hz]: "+
			dform(Cnt/(double)Splngf)+"[sec]");
	} catch(Exception e) {
            Error = "File read error.";
        }
    }
}